#ifndef ROUTEPLANNING_DEPENDENTDIJKSTRA_H_
#define ROUTEPLANNING_DEPENDENTDIJKSTRA_H_

#include <queue>
#include <utility>
#include <vector>
#include <string>
#include <functional>
#include "./TransitNetworkDependent.h"
#include "./EdgeDependent.h"
#include "./Label.h"
using std::string;
using std::pair;
using std::vector;
class DependentDijkstra
{
 public:
  DependentDijkstra(TransitNetworkDependent* roadNetwork);

  // find shortest path...
  double computeShortestPath(int startId, Time startTime,
                            int stopId, bool buildPath);

  // The vector contain strings in formate (stopName:ArrTime:DepTime:TripId),
  // which describe the shortpath from start- to end-node
  vector <string> transitShortestPath;
  size_t exploredNodes;
  int transfers;
  int time;
 private:
  // reconstruct shortest path..
  void reconstructShortestPath(size_t startId, size_t endId);
  TransitNetworkDependent* _tranGraph;
  bool _endStopFound;
  int _endStopId;
  int _endId;
  vector <Label> labels;
  vector <LabelSet> labelSets;
};
#endif  // ROUTEPLANNING_DEPENDENTDIJKSTRA_H_