#include "./Label.h"
#include <sstream>
using std::stringstream;
LabelSet::LabelSet()
{
  this->_labels = NULL;
  //this->
}

LabelSet::LabelSet(vector <Label>* labels, int transferTime)
{
  this->_labels = labels;
  //this->transferTime = transferTime;
}

void LabelSet::dominateBadLabels(int time, int transfers, int lineId, int transferTime,
                                bool expanded, bool EndStation,
                                int* posInTransferVector, int* posInTimeVector, bool multicriteria)
{
  int vectorId = _expandedFrom.size() - 1;
  size_t timeId = -1;
  //printf("dominateBadLabels1\n");
  while ((vectorId >=0 )
     &&(*_labels)[_expandedFrom[vectorId][0]].criterias[1] > transfers)
  {
    assert(multicriteria);
    timeId = _expandedFrom[vectorId].size() - 1;
    if ((*_labels)[_expandedFrom[vectorId][0]].criterias[0] >= time + transferTime)
    {
    //   printf("dominateBadLabels1_if\n");
      for (size_t k = 0; k < _expandedFrom[vectorId].size(); k++)
      {
        (*_labels)[_expandedFrom[vectorId][k]].removed = true;
        (*_labels)[_expandedFrom[vectorId][k]].removedByLabelId
                = _labels->size() - 1;
      }
      _expandedFrom.erase(_expandedFrom.begin() + vectorId);
    }
    else
    {
//       printf("dominateBadLabels1_else\n");
//       printf("%d of %zu\n",timeId, _expandedFrom[vectorId].size());
      while (timeId >= 0 && (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] >= time)
      {
        if ((*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] >= time + transferTime
         || lineId == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId
         || -1 == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId)
        {
          (*_labels)[_expandedFrom[vectorId][timeId]].removed = true;
          (*_labels)[_expandedFrom[vectorId][timeId]].removedByLabelId
                   = _labels->size() - 1;
           _expandedFrom[vectorId].erase(_expandedFrom[vectorId].begin() + timeId);
        }
//         printf("%d of %zu\n",timeId, _expandedFrom[vectorId].size());
        timeId--;
      }
      if (_expandedFrom[vectorId].size() == 0)
        _expandedFrom.erase(_expandedFrom.begin() + vectorId);
    }
    vectorId--;
  }
//  printf("dominateBadLabels2\n");
  if (vectorId >= 0
  && (*_labels)[_expandedFrom[vectorId][0]].criterias[1] == transfers)
  {
//    printf("dominateBadLabels2\n");
    timeId = _expandedFrom[vectorId].size() - 1;
//    printf("timeId=%d\n", timeId);
    if (((*_labels)[_expandedFrom[vectorId][0]].criterias[0] >= time
        && (expanded || EndStation))
      || ((*_labels)[_expandedFrom[vectorId][0]].criterias[0] >= time + transferTime
        && !multicriteria))
    {
      _expandedFrom[vectorId].resize(0);
      timeId = 0;
    }
    else
    {
      while (timeId >= 0 && (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] >= time)
      {
        if ((lineId == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId)
          || (-1 == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId)
          || (!multicriteria &&  (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] >= time + transferTime))
        {
          (*_labels)[_expandedFrom[vectorId][timeId]].removed = true;
          (*_labels)[_expandedFrom[vectorId][timeId]].removedByLabelId
                   = _labels->size() - 1;
           _expandedFrom[vectorId].erase(_expandedFrom[vectorId].begin()
                   + timeId);
        }
        timeId--;
      }
    }
  }
//  printf("dominateBadLabels3\n");
  *posInTransferVector = vectorId;
  *posInTimeVector = timeId;
}

bool LabelSet::labelMustBeAdded(int time, int transfers, int lineId, int trTime,
                                bool expanded, bool EndStation, bool multicriteria)
{
  int vectorId;
  int transferTime = trTime;
  if (expanded || EndStation)
    transferTime = 0;
  int lastVectorId = _expandedFrom.size() - 1;
  // Get position of needed Vector
//  if (EndStation) printf("time = %f %d %zu \n", time/60, lastVectorId, _expandedFrom.size());
  if ((*_labels)[_expandedFrom[0][0]].criterias[1] > transfers)
    return true;
  else if ((*_labels)[_expandedFrom[0][0]].criterias[1] == transfers)
    vectorId = 0;
  else if ((*_labels)[_expandedFrom[lastVectorId][0]].criterias[1] <= transfers)
    vectorId = lastVectorId;
  else
  {
    int left = 0 ;
    int right = lastVectorId;
    vectorId = (right + left) / 2;

    while (vectorId > left)
    {
      if ((*_labels)[_expandedFrom[vectorId][0]].criterias[1] < transfers)
        left = vectorId;
      else
        right = vectorId;
      vectorId = (right + left) / 2;
    }
    if ((vectorId < lastVectorId)&& (*_labels)[_expandedFrom[vectorId + 1][0]].criterias[1] <= transfers)
      vectorId++;
  }
  // Get right position in founded vector

  // the case if exist a vector where are conection with the same transfernumber
  // or this function was called from expanded dijkstra or
  // this labelset is a parityset of the endstation
  assert((*_labels)[_expandedFrom[vectorId][0]].criterias[1] <= transfers);
  if ((*_labels)[_expandedFrom[vectorId][0]].criterias[1] == transfers)
  {
    if (EndStation || expanded)
    {
      if ((*_labels)[_expandedFrom[vectorId].back()].criterias[0] <= time)
        return false;
//      else if ((*_labels)[_expandedFrom[vectorId][_expandedFrom[vectorId].size() - 1]].criterias[0] <= time
//             && (*_labels)[_expandedFrom[vectorId][_expandedFrom[vectorId].size() - 1]].connection.lineId == lineId)
//        return false;
      else
        return true;
    } else if ((*_labels)[_expandedFrom[vectorId][0]].criterias[0] <= time)
    {
      size_t timeId = 0;//_expandedFrom[vectorId].size() - 1;
      size_t timesVectorSize = _expandedFrom[vectorId].size();
      while (timeId < timesVectorSize
       && (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] <= time)
      {
        if ((lineId == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId)
            || (lineId == -1)
            || (!multicriteria && (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] + transferTime <= time))
          return false;
        timeId++;
      }
    }
    vectorId--;
  }
  while (vectorId >= 0)
  {
    assert((*_labels)[_expandedFrom[vectorId][0]].criterias[1] < transfers);
    size_t timeId = 0;
    size_t timesVectorSize = _expandedFrom[vectorId].size();
    if ((*_labels)[_expandedFrom[vectorId].front()].criterias[0] + transferTime <= time)
      return false;
    if ((*_labels)[_expandedFrom[vectorId].back()].criterias[0] > time)
      return true;
    // the case: it exist one label with the an id like label wich we check
    // between smallest label and smallest label + tranfertime
    else if ((*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] <= time)
      while (timeId < timesVectorSize
        && (*_labels)[_expandedFrom[vectorId][timeId]].criterias[0] + transferTime > time)
      {
        if ((lineId == (*_labels)[_expandedFrom[vectorId][timeId]].connection.lineId)
           || (lineId == -1))
          return false;
        timeId++;
      }
    vectorId--;
  }
  //printf("Ich darf hier nicht sein!!!!!!!!!!!!!!!");
  return true;
}

bool LabelSet::AddLabel(Connection stopTime, const vector<int>& criterias,
                      int NodeId, int expandedFromLabelId, NetworkType type,
                      bool expanded, bool EndStation,
                      bool createLabel, bool multicriteria)
{
  int time = criterias[0];
  int transfers = criterias[1];
  int trTime = 4 * 60;
  if (EndStation || expanded)
    trTime = 0;
  int labelId;
  if (createLabel)
    labelId = _labels->size();
  else
    labelId = expandedFromLabelId;
  if (_expandedFrom.size() == 0)
  {
    if (createLabel)
      _labels->push_back(Label(stopTime, criterias,
                                       NodeId, expandedFromLabelId, type));
    vector <int> buf;
    buf.push_back(labelId);
    _expandedFrom.push_back(buf);
    return true;
  }
  if (labelMustBeAdded(time, transfers,
                       stopTime.lineId, trTime, expanded, EndStation, multicriteria))
  {
//    if (EndStation)
//
//      printf("HURRRRRRRRRRRRRRRRRRRRRRRAAAAAAAAAAAAAAAAAAA -> time:%f tranfers:%f\n", time/60, transfers);
    if (createLabel)
      _labels->push_back(Label(stopTime, criterias,
                                       NodeId, expandedFromLabelId, type));
    int posInTranferVector;
    int posInTimeVector;
    dominateBadLabels(time, transfers, stopTime.lineId, trTime,
                      expanded, EndStation,
                      &posInTranferVector, &posInTimeVector, multicriteria);
    if (posInTranferVector < 0)
    {
     vector <int> buf;
      buf.push_back(labelId);
      _expandedFrom.insert(_expandedFrom.begin(), buf);
    } else if ((*_labels)[_expandedFrom[posInTranferVector][0]].criterias[1] < transfers )
    {
      posInTranferVector++;
      vector <int> buf;
      buf.push_back(labelId);
      _expandedFrom.insert(_expandedFrom.begin() + posInTranferVector, buf);
    } else if ((*_labels)[_expandedFrom[posInTranferVector][0]].criterias[1] == transfers )
    {
//      printf("%d\n", posInTimeVector);
      if (_expandedFrom[posInTranferVector].size() == 0
       ||_expandedFrom[posInTranferVector].size() - 1 == posInTimeVector )
      {
        _expandedFrom[posInTranferVector].push_back(labelId);
        assert(_expandedFrom[posInTranferVector].back()==labelId);
      } else
      {
        posInTimeVector++;
        _expandedFrom[posInTranferVector]
          .insert(_expandedFrom[posInTranferVector].begin() + posInTimeVector,
                  labelId);
        assert(_expandedFrom[posInTranferVector][posInTimeVector]==labelId);
      }
    }
  } else
    return false;

  return true;
}

//int LabelSet::getLabelIdbyExpandedId(size_t id)
//{
//  if (id >= _expandedFrom.size())
//    return -1;
//  return _expandedFrom[id];
//}

Label::Label()
{
  this->NodeId = -1;
  this->expandedFromLabelId = -1;
  this->removedByLabelId = -1;
  this->removed = false;
  this->netType = UNKNOWN;
}


Label::Label(Connection stopTime, const vector<int>& criterias,
             int NodeId, int expandedFromLabelId, NetworkType netType)
{
  this->connection = stopTime;
  this->criterias = criterias;
  this->NodeId = NodeId;
  this->expandedFromLabelId = expandedFromLabelId;
  this->removedByLabelId = -1;
  this->removed = false;
  this->netType = netType;
}



string Label::createCompressedJSON(int labelId, const Time& arrivalTime,
                                   int locationId) const
{
  stringstream jsonStream;
  // TODO(Robin): move type to label
  NetworkType type = this->netType;
  int weight = criterias[0] + criterias[1];
  int typeNr;
  if (type == ROADNETWORK)
    typeNr = 0;
  else
    typeNr = 1;
  jsonStream << "["
             << labelId << ","
             << typeNr << "," << locationId << "," << NodeId << ","
             << connection.lineId << ","
             << static_cast<int>(arrivalTime.hour()) << ","
             << static_cast<int>(arrivalTime.minute()) << ","
             << static_cast<int>(arrivalTime.second()) << ","
             << weight << "," << criterias[0] << "," << criterias[1] << ","
             << expandedFromLabelId << "," << removedByLabelId
             << "]";
  return jsonStream.str();
}


