/* Copyright Robin Schirrmeister and Simon Skilevic
 * Lecture Efficient Route Planning Summer Semester 2011
 * Uni Freiburg
 */

#ifndef ROUTEPLANNINGV2_LABEL_H_
#define ROUTEPLANNINGV2_LABEL_H_
#include <vector>
#include <functional>
#include <assert.h>
#include <gtest/gtest.h>
#include "./EdgeDependent.h"
#include "./LiveConnection.h"

using std::vector;
using std::pair;

class Label
{
 public:
  Label(Connection stopTime, const vector<int>& criterias,
        int NodeId, int expandedFromLabelId, NetworkType netType);
  string createCompressedJSON(int labelId, const Time& arrivalTime,
                              int locationId) const;
  Connection connection;
  int NodeId;
  int expandedFromLabelId;
  int removedByLabelId;
  bool removed;
  NetworkType netType;
  vector<int> criterias;
private:
  // making it private to prevent it from being accessed
  Label();
};

// TODO(Robin): remove node id from add label function
// and properly assign it in constructor instead
class LabelSet
{
 public:
  LabelSet();
  LabelSet(vector <Label>* labels, int transferTime);


  void dominateBadLabels(int time, int transfers, int lineId,
                         int transferTime, bool expanded, bool EndStation,
                         int* posInTransferVector, int* posInTimeVector,
                         bool multicriteria);
  FRIEND_TEST(LabelSetTest, labelMustBeAdded);
  bool labelMustBeAdded(int time, int transfers, int labelId, int trTime,
                        bool expanded, bool EndStation, bool multicriteria);
  bool AddLabel(Connection stopTime, const vector<int>& criterias,
                int NodeId, int expandedFromLabelId, NetworkType type,
                bool expanded, bool EndStation, bool createLabel,
                bool multicriteria);

  int nodeId;
  // TODO(Robin): rename as labelIds?
  vector <vector <int> > _expandedFrom;
 private:
  vector <Label>* _labels;
};



#endif  // ROUTEPLANNINGV2_LABEL_H_
