#ifndef ROUTEPLANNING_MULTICRITERIADEPENDENTDIJKSTRA_H_
#define ROUTEPLANNING_MULTICRITERIADEPENDENTDIJKSTRA_H_

#include <queue>
#include <utility>
#include <vector>
#include <string>
#include <functional>
#include "./TransitNetworkDependent.h"
#include "./EdgeDependent.h"
#include "./Label.h"
#include "./TransitPath.h"
using std::string;
using std::pair;
using std::vector;
class MulticriteriaDependentDijkstra
{
 public:
  MulticriteriaDependentDijkstra(TransitNetworkDependent* roadNetwork);

  // convenience function, just calls the function below
  double computeShortestPath(string startStop, Time time,
                             string endStop, bool buildPath);
  FRIEND_TEST(MulticriteriaDependentTest, computeShortestPath);
  // find shortest path...
  double computeShortestPath(int startId, Time startTime,
                            int stopId, bool buildPath);
  // The vector contain strings in formate (stopName:ArrTime:DepTime:TripId),
  // wich discribe the shortpath from start- to end-node
  vector <string> transitShortestPath;
  vector<TransitPath> optimalPaths;
  size_t exploredNodes;
  int transferMax;
  int timeMax;
 private:
  // reconstruct shortest path..
  void reconstructShortestPath(const Time& startTime,
                               size_t startId,
                               size_t endId);
  TransitNetworkDependent* _tranGraph;
  bool _endStopFound;
  int _endStopId;
  int _endId;
  vector <Label> labels;
  vector <LabelSet> labelSets;
};
#endif  // ROUTEPLANNING_MULTICRITERIADEPENDENTDIJKSTRA_H_
