// Copyright Simon Skilevic and Robin Schirrmeister
// Road Network class, just a graph with a method to read from an osmfile..

#ifndef ROUTEPLANNINGV2_ROADNETWORK_H_
#define ROUTEPLANNINGV2_ROADNETWORK_H_

#include <map>
#include <string>
#include "./Graph.h"
#include "./LiveConnection.h"

class RoadNetwork : public Graph
{
public:
  RoadNetwork();
  // construct the graph from given osm-file
  void readFromOsmFile(string fileName);
  void getNearestNodesIdsSIMPLE(double latitude, double longitude,
                                size_t naighboursNumber, double speedInKmh,
                                vector<Edge>* nearestNodes);
  void getConnections(int nodeId, Time arrivalTime, bool isStartNode,
                                    vector<LiveConnection>* outConnections);

  // parse the road network from a string representation
  void parseFromString(string graphString);
  // return a string representation of the road network
  string toString();
private:
  // for the parsing process...
  void makeEdge(const string &line, FILE* osmFile,
                map<string, int>* idMap,
                const map<string, size_t>& speedTable);
  void makeNode(const string &line, map<string, int>* _idMap);
};

#endif  // ROUTEPLANNINGV2_ROADNETWORK_H_

