// Copyright 2011 Simon Skilevic and Robin Schirrmeister

// draws the given path as a polyline..
// path is given as an array with latitude and longitude coordinates like this:
// lat1, long1, lat2, long2, lat3, long3...
function drawPath(path)
{
  // remove polyline from map if already present
  if (way != null){
      way.setMap(null);
  }
  // create polyline, then add path
  way = new google.maps.Polyline({
    path: [],
    strokeColor: "#0000FF",
    strokeOpacity: 1.0,
    strokeWeight: 2
  });
  for (i = 0; i < path.length; i = i + 2) 
  {
    way.getPath().push(new google.maps.LatLng(path[i], path[i + 1]));
  }
  way.setMap(map);
}

// executed once json request has been answered
function callback(json, text, xhqr)
{  
  // get the startnode, the endnode and the path and display them...
  var startNode = new google.maps.LatLng(json.startNode.latitude, 
                                     json.startNode.longitude);
  var endNode = new google.maps.LatLng(json.endNode.latitude, 
                                     json.endNode.longitude);
  var path = json.path;
  markers[0].setPosition(startNode);
  markers[1].setPosition(endNode);
  drawPath(path);
  // also display google's calculated route
  displayGoogleRoute(startNode, endNode);
}

// called when marker is dragged
function moveMarker(id)
{
  sendMarkersPos(markers[0].getPosition(), markers[1].getPosition());
}
// display the route that google map calculates for given start and end location
function displayGoogleRoute(startLocation, endLocation)
{
  var request = {
    origin:startLocation,
    destination:endLocation,
    travelMode: google.maps.TravelMode.DRIVING
  };
  directionsService.route(request, function(result, status) {
    if (status == google.maps.DirectionsStatus.OK) {
      //directionsDisplay.setDirections(result);
    }
  });
}
// send the marker position to the proper server by ajax-request
// and execute callback function on return
function sendMarkersPos(locA, locB)
{
  var url = "http://stromboli.informatik.uni-freiburg.de:5274/"
          + locA
          + locB;
  $.ajax(url, { dataType: "jsonp" });
}

function setMarker(pos){

  if (mNumber == 2){
    // remove markers and the displayed route from the map
    mNumber = 0;
    way.setMap(null);
    markers[0].setMap(null);
    markers[1].setMap(null);
  }
  markers[mNumber] = new google.maps.Marker({
    position: pos,
    draggable: true,
    map: map
  });
  mNumber++;
  // if two markers have been put on the map, calculate the route
  if (mNumber == 2){
    sendMarkersPos(markers[0].getPosition(), markers[1].getPosition());
    google.maps.event.addListener(markers[0],
      'drag', function(event){ moveMarker(0); });
    google.maps.event.addListener(markers[1],
      'drag', function(event){ moveMarker(1); });
  }
}

$(document).ready(function(){
  var latlng = new google.maps.LatLng(49.23, 7.0);
  var myOptions = {
    zoom: 15,
    center: latlng,
    mapTypeId: google.maps.MapTypeId.ROADMAP
  };
  map = new google.maps.Map(document.getElementById("map_canvas"),
    myOptions);
  google.maps.event.addListener(map,
    'click', function(event){ setMarker(event.latLng); });  
  // set the renderer for google map routes...
  directionsDisplay = new google.maps.DirectionsRenderer();
  directionsDisplay.setMap(map);

});
var directionDisplay;
var directionsService = new google.maps.DirectionsService();
var markers = new Array(2);
var way;
var mNumber = 0;
var map;
